'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var defaultAction = exports.defaultAction = function defaultAction(ACTION_NAME) {
  return function (payload) {
    return {
      type: ACTION_NAME,
      payload: payload
    };
  };
};

// TODO: add support for user namespace format settings


var asyncActionNames = exports.asyncActionNames = function asyncActionNames(name) {
  return {
    GET: name + '/GET',
    POST: name + '/POST',
    RECEIVE: name + '/RECEIVE',
    ERROR: name + '/ERROR',
    RESET: name + '/RESET'
  };
};

var defaultAsyncActions = exports.defaultAsyncActions = function defaultAsyncActions(ASYNC_ACTION_NAMES) {
  return {
    get: defaultAction(ASYNC_ACTION_NAMES.GET),
    post: defaultAction(ASYNC_ACTION_NAMES.POST),
    receive: defaultAction(ASYNC_ACTION_NAMES.RECEIVE),
    error: defaultAction(ASYNC_ACTION_NAMES.ERROR),
    reset: defaultAction(ASYNC_ACTION_NAMES.RESET)
  };
};

var actionBundle = exports.actionBundle = function actionBundle(name) {
  var ACTION_NAME = name;
  var action = defaultAction(ACTION_NAME);
  return [ACTION_NAME, action];
};

var asyncActionBundle = exports.asyncActionBundle = function asyncActionBundle(name) {
  var ACTION_NAMES = asyncActionNames(name);
  var defaultActions = defaultAsyncActions(ACTION_NAMES);
  return [ACTION_NAMES, defaultActions];
};