'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ACTION_MANAGER = undefined;
exports.default = reducer;

var _immutable = require('immutable');

var ACTION_MANAGER = exports.ACTION_MANAGER = {
  REGISTER: '@ActionManager/register'
}; /**
    * REQUIREMENT:
    * create the action-creator util as an open-source library
    * namespace collision check
    * use flow to do object type check
    */

var initialState = (0, _immutable.Set)();

var register = function register(state, actionName) {
  var toBeRegistered = typeof actionName === 'string' ? (0, _immutable.Set)(actionName) : (0, _immutable.Set)(Object.values(actionName));
  var conflicts = state.intersect(toBeRegistered).length;
  if (conflicts) {
    return console.log('action namespace conflicts:', actionName);
  }
  return state.union(toBeRegistered);
};

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case ACTION_MANAGER.REGISTER:
      return register(state, action.payload);
    default:
      return state;
  }
}

// TODO?: the middleware actually creates and manage default reducers for all async actions

// TODO?: further define get(query) post(data) type
// TODO: actionManagerMiddleware({prefix, delimiter})
// a middleware creator that creates a `actions` namespace in the store
// it allows users to customise format of action namespace
// it takes names from register functions and check if it conflicts with the namespace
// export const actionManagerMiddleware = ({ prefix: string, delimiter: string }) => store => next => (action) => {
//   next(action);
//   // TODO: parse and validate the actionNameSpace format
// };

// TODO: registerAsyncAction()
// it register the action name in the namespace and receive confirmation
// and returns the default asyncAction names

// TODO: registerAction()
// it register the action name in the namespace and receive confirmation